//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymRChkDlgs.h"
#include "NymRepDlgs.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNymRchkDlg *NymRchkDlg;
//---------------------------------------------------------------------------
bool __fastcall ReplyBlocksValid(TForm *Owner, TStrings *replyblocks, int &blks, int &errs)
{
   NymRchkDlg = new TNymRchkDlg(Owner);
   NymRchkDlg->Execute(replyblocks);
   blks = NymRchkDlg->blks;
   errs = NymRchkDlg->errs;
   delete NymRchkDlg;
   return errs==0;
}
//---------------------------------------------------------------------------
__fastcall TNymRchkDlg::TNymRchkDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   dirs = new TStringList();
   hdrs = new TStringList();
   rems = new TStringList();
   longs = new TStringList();
   shrts = new TStringList();
   GetCpkRemailerShortsEqualLongs(rems);
   GetCpkRemailerShorts(shrts,rems);
   GetCpkRemailerLongs(longs,rems);
   GetCpkDirectives(dirs);
}
//---------------------------------------------------------------------------
__fastcall TNymRchkDlg::~TNymRchkDlg()
{
   delete shrts;
   delete longs;
   delete rems;
   delete hdrs;
   delete dirs;
}
//---------------------------------------------------------------------------
void __fastcall TNymRchkDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Sleep(50); Label1->Visible = true;  AppProcessMessages();
   GetReplyBlockErrors();
   Sleep(400); Label1->Visible = false; AppProcessMessages();
   ModalResult = mrOk;
   Sleep(100);
}
//---------------------------------------------------------------------------
void __fastcall TNymRchkDlg::FlagLine(AnsiString &line, AnsiString errmsg)
{
   Graphics::TBitmap *bmp = new Graphics::TBitmap();
   while (bmp->Canvas->TextWidth(line)<200) line += " ";
   line += "  <---  "+errmsg;
   delete bmp;
}
//---------------------------------------------------------------------------
void __fastcall TNymRchkDlg::Execute(TStrings *replyblocks)
{
   ReplyBlocks = replyblocks;
   Timer1->Enabled = true;
   ShowModal();
}
//---------------------------------------------------------------------------
bool __fastcall TNymRchkDlg::GetNextReplyBlock(TStrings *block, TStrings *blocks)
{
   block->Clear();
   while(blocks->Count && blocks->Strings[0].TrimLeft().Pos("Reply-Block:")==0)
      blocks->Delete(0);
   while(blocks->Count)
   {
      AnsiString rbline = blocks->Strings[0];
      if (rbline.Trim().IsEmpty()) break;

      int pos = rbline.Pos("<---");
      if (pos>0) rbline = rbline.SubString(1,pos-1).TrimRight();
      block->Add(rbline);
      blocks->Delete(0);
   }
   return block->Count>0;
}
//---------------------------------------------------------------------------
int __fastcall TNymRchkDlg::GetReplyBlockErrors()
{
   errs=0,blks=0;
   TStringList *block = new TStringList();
   TStringList *blocks = new TStringList();
   TStringList *chkdblocks = new TStringList();

   blocks->AddStrings(ReplyBlocks);
   while(GetNextReplyBlock(block,blocks))
   {
      blks++; ReplyBlockValid(block);
      if (chkdblocks->Count) chkdblocks->Add("");
      chkdblocks->AddStrings(block);
   }
   for (int i=0; i<chkdblocks->Count; i++)
      if (chkdblocks->Strings[i].LowerCase().Pos("<--- unknown")>0) errs++;
   ReplyBlocks->Text = chkdblocks->Text;

   delete chkdblocks;
   delete blocks;
   delete block;
   return errs;
}
//---------------------------------------------------------------------------
bool __fastcall valideaddress(AnsiString addr)
{
   int pos = addr.Pos("@");
   return pos>1 && addr.SubString(pos,256).Pos(".");
}
//---------------------------------------------------------------------------
bool __fastcall TNymRchkDlg::ReplyBlockValid(TStrings *block)
{
   AnsiString rbline,userid,userid2,remail,remail2;
   int c = block->Count;
   for (int i=c-1; i>0; i--)
   {
      rbline = block->Strings[i];
      if (line.Pos(":")==0 && !userid.IsEmpty())
      {
         // this line is not a directive so it must be a user or remailer name/address
         if (leg>0 && shrts->IndexOf(line)<0 && longs->IndexOf(line)<0)
            FlagLine(errs,i,block,"Unknown remailer");
         leg++;
      }
      if (i==c-1)
      {
         userid = rbline;
         if (!valideaddress(userid))
            block->Strings[i] = userid+"  <---- invalid email address";
         continue;
      }

      if (rbline.Pos("-To:")>0)
      {
         if (userid2.IsEmpty())
         {
            userid = rbline;
            if (!valideaddress(userid))
               block->Strings[i] = userid+"     <---- invalid email address";
            continue;
         }
      }
   }
   return true;
}
//---------------------------------------------------------------------------
/*bool __fastcall TNymWizDlg::ReplyBlocksValid(TForm *Owner, TStrings *block)
{
   SetRedraw(this,0);
   int pos,leg,errs=0;
   AnsiString line,label,addr,rem;
   TList *bads = new TList();
   TStringList *dirs = new TStringList();
   TStringList *hdrs = new TStringList();
   TStringList *rems = new TStringList();
   TStringList *longs = new TStringList();
   TStringList *shrts = new TStringList();
   GetCpkRemailerShortsEqualLongs(rems);
   GetCpkRemailerShorts(shrts,rems);
   GetCpkRemailerLongs(longs,rems);
   GetCpkDirectives(dirs);
   GetCpkHeaders(hdrs);
   // remove previous error flags
   for (int i=0; i<block->Count; i++)
   {
      rem = block->Strings[i];
      if ((pos=rem.Pos("<---"))>0)
         block->Strings[i] = rem.SubString(1,pos-1).TrimRight();
   }
   // dump null lines
   TrimNulls(block);
   while (block->Count && block->Strings[0].Trim().Pos("Reply-Block:")!=1)
      block->Delete(0);
   block->Insert(0,"");
   block->Add(""); // add for tripping leg 0 at end of blocks

   // check all lines individually no matter the count
   for (int i=block->Count-1; i>0; i--)
   {
      line = block->Strings[i].Trim();
      if (line.IsEmpty()) // end of reply block
      {
         leg = 0; i--; continue;
      }

      if (line.Pos(":")==0)
      {
         // this line is not a directive so it must be a user or remailer name/address
         if (leg>0 && shrts->IndexOf(line)<0 && longs->IndexOf(line)<0)
            FlagLine(errs,i,block,"Unknown remailer");
         leg++;
      }
      else
      {
         // there is at lease a directive or header (could be just "Reply-Block:")
         label = GetToken(0,line," ");
         if (dirs->IndexOf(label)<0 && hdrs->IndexOf(label)<0)
            FlagLine(errs,i,block,"Unknown directive");
         else
         {
            if (label.Pos("-To:")) // this line will have a name or address
            {
               addr = GetToken(1,line," ");
               if (leg>0 && shrts->IndexOf(addr)<0 && longs->IndexOf(addr)<0)
                  FlagLine(errs,i,block,"Unknown remailer");
            }
         }
      }
   }
   TrimNulls(block);
   delete shrts;
   delete longs;
   delete rems;
   delete hdrs;
   delete dirs;
   delete bads;
   bool baddir = block->Text.Pos("Unknown directive")>0;
   bool badrem = block->Text.Pos("Unknown remailer")>0;
   AnsiString badremmsg,baddirmsg,errormsg;
   badremmsg =
      s("I have discovered 1 or more unknown remailers in your reply block.\n")+
      s("I'll flag the line(s). Please have a look. You probably have a typo!");
   baddirmsg =
      s("I have discovered 1 or more unknown directives (or headers) in\n")+
      s("your reply block. I'll flag the line(s). Please have a look. You may\n")+
      s("have a typo.\n\n")+
      s("If you are using a directive that is not on the editor Directives Menu,\n")+
      s("or a message header not on the Headers Menu, see the Help topic\n")+
      s("'Directives and Header Requirements'.");
   errormsg = (badrem ? badremmsg : s(""))+(badrem && baddir ? "\n\n" : "")+
      (baddir ? baddirmsg : s(""));
   if (errs) MsgBoxHwnd(Owner->Handle,errormsg,"Reply Block Error",MB_OK);
   SetRedraw(this,1);
   return !baddir && !badrem;
}
*/

