//---------------------------------------------------------------------------
// MixDir() is in global.cpp
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpDlgs.h"
#include "Pgpfiles.h"
#include "PGPbuffers.h"
#include "Global.h"
//#include "WipeDlgs.h"
#include "pgp.h"
#include "Mixmaster.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpDlg *PgpDlg;
//---------------------------------------------------------------------------
void __fastcall Wipefile(AnsiString &filename, int passes)
{
   ActMainForm->Perform(WM_WIPEFILE,(WPARAM)passes,(LPARAM)filename.c_str());
}
//---------------------------------------------------------------------------
__fastcall TPgpDlg::TPgpDlg(TComponent* Owner)
  : TForm(Owner)
{
   TheRecips = new TStringList();
   encid8s = new TStringList();
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpDlg::TPgpDlg(AnsiString PubRing, AnsiString SecRing, AnsiString RemRing,
   TForm* Owner) : TForm(Owner)
{
   dat = buf_new(); pas = buf_new(); enc = buf_new(); sig = buf_new();
   dat->sensitive = pas->sensitive = enc->sensitive = sig->sensitive = true;
   PKeyRing = PubRing; SKeyRing = SecRing; RKeyRing = RemRing;
   TheRecips = new TStringList();
   encid8s = new TStringList();
   MainForm = (TForm*)Owner;
   ToRemailer = false;
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpDlg::~TPgpDlg()
{
   delete encid8s;
   delete TheRecips;
   buf_free(pas);
   buf_free(dat);
   buf_free(enc);
}
//---------------------------------------------------------------------------
bool __fastcall TPgpDlg::IsRemailed(TStrings *Recips)
{
   bool remail = false;
   TPGPbuffer *cpkkeys = new TPGPbuffer(PgpRemailRing(),NO_DISABLED);
   AnsiString cpknames = cpkkeys->getuserids();
   for (int i=0; i<Recips->Count; i++)
   {
       if (cpknames.Pos(Recips->Strings[i])>0)
       {
          remail = true;
          break;
       }
   }
   delete cpkkeys;
   return remail;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::EncryptMessage(TStrings *Message, TStrings *Recips)
{
   AnsiString line;
   encid8s->Clear();
   // split recips lines to idtext8 and userid
   for (int i=0; i<Recips->Count; i++)
   {
      line = Recips->Strings[i];
      encid8s->Add(line.SubString(3,8));
      Recips->Strings[i] = line.SubString(12,128);
   }

   Caption = "Pgp Encrypt"; Sleep(100);
   Cap = "...encrypting...";
   Label1->Caption = Cap;
   AppProcessMessages();
   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,s(Message->Strings[i]+"\n").c_str());
   for (int i=0; i<Recips->Count; i++)
      buf_appends(enc,s(Recips->Strings[i]+"\n").c_str());

   switch (Execute(mPGPencrypt))
   {
      case PGP_OK  : Message->Text = AnsiString((char*)dat->data); break;
      case PGP_ERR : PGPerror("Specified public key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result==PGP_OK)
   {
      if (IsRemailed(Recips)) Message->Insert(0,"::\r\nEncrypted: PGP\r\n");
      return Result;
   }
   ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::SignMessage(TStrings *Message, AnsiString &SigId,
   AnsiString &passphrase, AnsiString *SigId8) // sigid8 was added later for tmpSecring
{
   int pos;
   AnsiString line,text;
   if (SigId8) sigid8 = *SigId8;
   Caption = "Pgp Sign";  Sleep(100);
   Cap = "...signing..."; Label1->Caption = Cap;
   buf_sets(pas,passphrase.c_str());
   buf_sets(sig,SigId.c_str());
   Application->ProcessMessages();

   if (ToRemailer)
   {
      text = Message->Text;
      if ((pos=text.Pos("\r\n\r\n"))==text.Pos("\r\n\r\n::\r\n")) text.Delete(pos,2);
      if ((pos=text.Pos("\r\n\r\n"))==text.Pos("\r\n\r\n##\r\n")) text.Delete(pos,2);
      Message->Text = text;
   }

   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());

   switch (Execute(mPGPsign))
   {
      case PGP_OK : Message->SetText((char*)dat->data); break;
      case PGP_ERR: PGPerror("Specified signing key not found!"); break;
      default: PGPerror("PGP signing error: "+AnsiString(Result));
   }

   if (ToRemailer)
   {
      text = Message->Text;
      if ((pos=text.Pos("\r\n::\r\n"))>0) text.Insert("\r\n",pos);
      if ((pos=text.Pos("\r\n##\r\n"))>0) text.Insert("\r\n",pos);
      Message->Text = text;
   }

   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::EncryptCMessage(TStrings *Message, AnsiString &Passphrase)
{
   Caption = "Pgp Encrypt"; Sleep(100);
   Cap = "...encrypting...";
   Label1->Caption = Cap;
   Application->ProcessMessages();
   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,s(Message->Strings[i]+"\n").c_str());
   buf_appends(enc,Passphrase.c_str()); ClearString(Passphrase);
   switch (Execute(mPGPencryptc))
   {
      case PGP_OK  : Message->Text = (char*)dat->data; break;
      case PGP_ERR : PGPerror("Specified key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::EncryptSignMessage(TStrings *Message, AnsiString &SigId,
   AnsiString &passphrase, TStrings *Recips, AnsiString *SigId8,
   AnsiString *EncId8)
{
   AnsiString line;
   if (SigId8) sigid8 = *SigId8;
   encid8s->Clear();
   for (int i=0; i<Recips->Count; i++)
   {
      line = Recips->Strings[i];
      encid8s->Add(line.SubString(3,8));
      Recips->Strings[i] = line.SubString(12,128);
   }

   Caption = "Pgp Sign Encrypt"; Sleep(100);
   Cap = "...signing/encrypting..."; Label1->Caption = Cap;
   Application->ProcessMessages();

   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());
   for (int i=0; i<Recips->Count; i++)
      buf_appends(enc,s(Recips->Strings[i]+"\n").c_str());

   buf_sets(pas,passphrase.c_str());
   buf_sets(sig,SigId.c_str());

   switch (Execute(mPGPencryptsign))
   {
      case PGP_OK  : Message->Text = AnsiString((char*)dat->data); break;
      case PGP_ERR : PGPerror("Specified public key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result==PGP_OK && ToRemailer) Message->Insert(0,"::\r\nEncrypted: PGP\r\n");
   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
AnsiString __fastcall ConvertSigTime(AnsiString sigtim)
{
   int h;
   sigtim = sigtim.LowerCase().Trim();
   AnsiString date,hr,mn,sc,tm,yr,dy,mt,ampm="AM",
      mts="~~~janfebmaraprmayjunjulaugsepoctnovdec";
   mt = s(mts.Pos(GetToken(1,sigtim," "))/3); while (mt.Length()<2) mt = "0"+mt;
   dy = "/"+GetToken(2,sigtim," ")+"/";
   yr = GetToken(4,sigtim," ").SubString(3,2);
   tm = GetToken(3,sigtim," ");
   hr = GetToken(0,tm,":"); while (hr.SubString(1,1)=="0") hr = hr.SubString(2,1);
   h  = hr.ToIntDef(0); if (h>12) { ampm = "PM"; h -= 12; }
   hr = h; //while (hr.Length()<2) hr = "0"+hr;
   mn = ":"+GetToken(1,tm,":")+":";
   sc = GetToken(2,tm,":");
   return mt+dy+yr+" "+hr+mn+sc+" "+ampm;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::DecryptMessage(BUFFER *Message, AnsiString &passphrase)
{
   AnsiString line,date,sigdat,sigtim,signer;
   BUFFER *msg = Message;
   Caption = "Pgp Decrypt"; //Sleep(100);
   Cap = "...decrypting message..."; Label1->Caption = Cap;
   Application->ProcessMessages();
   buf_set(dat,msg);
   buf_sets(pas,passphrase.c_str());
   buf_clear(sig);
   switch (Execute(mPGPdecrypt))
   {
      case PGP_OK: buf_set(msg,dat); break;
      case PGP_ERR: PGPerror("The message can't be read."); break;
      case PGP_PASS: PGPerror("Bad passphrase."); break;
      case PGP_NOMSG: PGPerror("Message is not an OpenPGP message."); break;
      case PGP_NODATA: PGPerror("OpenPGP message does not contain user data."); break;
      case PGP_SIGOK:
         sigdat = (char*)sig->data;
         signer = GetToken(0,sigdat,"[")+"\n";
         sigtim = ConvertSigTime(GetToken(1,sigdat,"["))+"\n";
         date = FormatDateTime("mm/dd/yy h:nn:ss ampm\n",Now());
         buf_sets(msg,   "*** PGP Signature Status: good\n");
         buf_appends(msg,"*** Signer: "); buf_appends(msg,signer.c_str());
         buf_appends(msg,"*** Signed: "); buf_appends(msg,sigtim.c_str()); 
         buf_appends(msg,"*** Verified: "); buf_appends(msg,date.c_str());
         buf_appends(msg,"*** BEGIN PGP DECRYPTED/VERIFIED MESSAGE ***\n\n");
         buf_cat(msg,dat);
         buf_appends(msg,"\n*** END PGP DECRYPTED/VERIFIED MESSAGE ***\n");
         break;
      case PGP_SIGBAD:
         sigdat = (char*)sig->data;
         signer = GetToken(0,sigdat,"[")+"\n";
         sigtim = ConvertSigTime(GetToken(1,sigdat,"["))+"\n";
         date = FormatDateTime("mm/dd/yy h:nn:ss ampm\n",Now());
         buf_sets(msg,   "*** PGP Signature Status: bad\n");
         buf_appends(msg,"*** Signer: "); buf_appends(msg,signer.c_str());
         buf_appends(msg,"*** Signed: "); buf_appends(msg,sigtim.c_str());
         buf_appends(msg,"*** Verified: "); buf_appends(msg,date.c_str());
         buf_appends(msg,"*** BEGIN PGP DECRYPTED/VERIFIED MESSAGE ***\n\n");
         buf_cat(msg,dat);
         buf_appends(msg,"\n*** END PGP DECRYPTED/VERIFIED MESSAGE ***\n");
         break;
      case PGP_SIGNKEY:
         sigdat = (char*)sig->data;
         signer = GetToken(0,sigdat,"[")+"\n";
         sigtim = ConvertSigTime(GetToken(1,sigdat,"["))+"\n";
         date = FormatDateTime("mm/dd/yy h:nn:ss ampm\n",Now());
         buf_sets(msg,   "*** PGP Signature Status: unknown\n");
         buf_appends(msg,"*** Signer: 0x"); buf_appends(msg,signer.c_str());
         buf_appends(msg,"*** Signed: --/--/--\n"); //buf_appends(msg,sigtim.c_str());
         buf_appends(msg,"*** Verified: "); buf_appends(msg,date.c_str());
         buf_appends(msg,"*** BEGIN PGP DECRYPTED/VERIFIED MESSAGE ***\n\n");
         buf_cat(msg,dat);
         buf_appends(msg,"\n*** END PGP DECRYPTED/VERIFIED MESSAGE ***\n");
         break;
   }
   if (Result!=PGP_OK && Result!=PGP_SIGOK && Result!=PGP_SIGBAD && Result!=PGP_SIGNKEY)
      ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
char* __fastcall PoundString(int length)
{
   AnsiString poundline;
   return s(poundline.StringOfChar('#',length)+"\n").c_str();
}
int __fastcall TPgpDlg::VerifyMessage(BUFFER *Message, BUFFER *Sig)
{
   AnsiString line,id;
   Caption = "Pgp Verify"; Sleep(100);
   Cap = "...checking signature..."; Label1->Caption = Cap;
   TStringList *tmp = new TStringList();
   Application->ProcessMessages();
   buf_set(dat,Message);
   //buf_set(sig);
   int minwide=58;
   switch (Execute(mPGPverify))
   {
      case PGP_OK: buf_set(Message,dat); break;
      case PGP_ERR: PGPerror("The message can't be read."); break;
      case PGP_PASS: PGPerror("Bad passphrase."); break;
      case PGP_NOMSG: PGPerror("Message is not an OpenPGP message."); break;
      case PGP_NODATA: PGPerror("OpenPGP message does not contain user data."); break;
      case PGP_SIGOK:
         buf_sets(Message,PoundString(sig->length<minwide-6 ? minwide:sig->length+6));    //"##################################");
         buf_appends(Message,"# "); buf_cat(Message,dat); buf_appendc(Message,'\n');
         buf_appends(Message,"# Digital Signature OK\n\n");
         buf_cat(Message,sig);
         break;
      case PGP_SIGBAD:
         buf_sets(Message,PoundString(sig->length<minwide-10 ? minwide:sig->length+10));    //"##################################");
         buf_appends(Message,"# Key "); buf_cat(Message,sig); buf_appendc(Message,'\n');
         buf_appends(Message,"# Verify FAILED, bad digital signature\n#\n\n");
         buf_cat(Message,dat);
         break;
      case PGP_SIGNKEY:
         tmp->SetText((char*)sig->data);
         sm(tmp->Text);
         if (tmp->Count)
         {
            id = tmp->Strings[tmp->Count-1];
            if (!id.IsEmpty()) id = " 0x"+id;
            tmp->Delete(tmp->Count-1);
            buf_sets(sig,tmp->Text.c_str());
         }
         buf_sets(Message,PoundString(minwide));
         buf_appends(Message,"# Unknown key"); buf_appends(Message,id.c_str());
         buf_appends(Message,", Can't verify digital signature\n");
         buf_appends(Message,"#\n");
         buf_cat(Message,sig);
         break;
   }
   if (Result!=PGP_OK && Result!=PGP_SIGOK && Result!=PGP_SIGBAD && Result!=PGP_SIGNKEY)
      ModalResult = mrCancel;
   delete tmp;
   return Result;
}
//---------------------------------------------------------------------------
TPGPbuffer* __fastcall TPgpDlg::GetAllPublicKeys()
{
   TPGPbuffer *key,*per,*cpk,*pubs = new TPGPbuffer();
   per = new TPGPbuffer(PKeyRing,NO_DISABLED);
   cpk = new TPGPbuffer(RKeyRing,NO_DISABLED);
   key = new TPGPbuffer();

   while (key->copykeyfrom(per))
   {
      if (!pubs->keyexists(key)) pubs->copyfrom(key);
      key->clear();
   }
   while (key->copykeyfrom(cpk))
   {
      if (!pubs->keyexists(key)) pubs->copyfrom(key);
      key->clear();
   }

   delete key;
   delete cpk;
   delete per;
   return pubs;
}
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::Timer1Timer(TObject *Sender)
{
   int i;
   Label1->Caption = Cap;
   Timer2->Enabled = true;
   Timer1->Enabled = false;
   AppProcessMessages();
   TPGPbuffer *key,*pubs,*cpk,*per,*secs;
   TStringList *id8s,*msg = new TStringList();
   AnsiString id8,tmpPubring = GetTempFilename();
   AnsiString tmpSecring = tmpPubring+"_";
   switch (Mode)
   {
      case mPGPverify:
         pubs = GetAllPublicKeys();
         pubs->SaveToFile(tmpPubring);
         Result = pgp_decrypt(dat,NULL,sig,tmpPubring.c_str(),NULL);
         Wipefile(tmpPubring,3);
         delete pubs;
         break;
      case mPGPdecrypt:
         key = new TPGPbuffer();
         per = new TPGPbuffer(PKeyRing,NO_DISABLED);
         cpk = new TPGPbuffer(RKeyRing,NO_DISABLED);
         pubs = new TPGPbuffer();
         id8s = new TStringList();
         while (key->copykeyfrom(per))
         {
            AppProcessMessages();
            id8 = key->idtext8;
            if (id8s->IndexOf(id8)<0)
            {
               pubs->copyfrom(key);
               id8s->Add(id8);
            }
            key->clear();
         }
         while (key->copykeyfrom(cpk))
         {
            AppProcessMessages();
            id8 = key->idtext8;
            if (id8s->IndexOf(id8)<0)
            {
               pubs->copyfrom(key);
               id8s->Add(id8);
            }
            key->clear();
         }
         delete id8s;
         pubs->SaveToFile(tmpPubring);
         Result = pgp_decrypt(dat,pas,sig,tmpPubring.c_str(),SKeyRing.c_str());
         Wipefile(tmpPubring,3);
         delete pubs;
         delete cpk;
         delete per;
         delete key;
         break;
      case mPGPsign:
         key = new TPGPbuffer();
         secs = new TPGPbuffer(SKeyRing);
         if (!sigid8.IsEmpty() && secs->get(sigid8,key)) key->SaveToFile(tmpSecring);
         else secs->SaveToFile(tmpSecring);

         Result = pgp_mailenc(PGP_SIGN,dat,(char*)sig->data,pas,NULL,tmpSecring.c_str());
         Wipefile(tmpSecring,3);
         delete secs;
         delete key;
         break;
      case mPGPencrypt:
         key = new TPGPbuffer();
         pubs = new TPGPbuffer();
         per = new TPGPbuffer(PKeyRing,NO_DISABLED);
         cpk = new TPGPbuffer(RKeyRing,NO_DISABLED);
         for (i=0; i<encid8s->Count; i++)
         {
            id8 = encid8s->Strings[i];
            if (per->get(id8,key) || cpk->get(id8,key)) pubs->copyfrom(key);
         }
         pubs->SaveToFile(tmpPubring);

         Result = pgp_encrypt(PGP_ENCRYPT|PGP_TEXT,dat,enc,NULL,NULL,
            tmpPubring.c_str(), NULL);

         Wipefile(tmpPubring,3);
         delete pubs;
         delete cpk;
         delete per;
         delete key;
         break;
      case mPGPencryptc:
         Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_TEXT,dat,enc,NULL,NULL,NULL,NULL);
         break;
      case mPGPencryptsign:
         key = new TPGPbuffer();
         secs = new TPGPbuffer(SKeyRing);
         if (!sigid8.IsEmpty() && secs->get(sigid8,key)) key->SaveToFile(tmpSecring);
         else secs->SaveToFile(tmpSecring);

         key->clear();
         pubs = new TPGPbuffer();
         per = new TPGPbuffer(PKeyRing,NO_DISABLED);
         cpk = new TPGPbuffer(RKeyRing,NO_DISABLED);
         for (int i=0; i<encid8s->Count; i++)
         {
            id8 = encid8s->Strings[i];
            if (per->get(id8,key) || cpk->get(id8,key)) pubs->copyfrom(key);
         }
         pubs->SaveToFile(tmpPubring);

         Result = pgp_encrypt(PGP_ENCRYPT|PGP_SIGN|PGP_TEXT,dat,enc,sig,pas,
            tmpPubring.c_str(),tmpSecring.c_str());

         Wipefile(tmpPubring,3);
         Wipefile(tmpSecring,3);
         delete secs;
         delete pubs;
         delete cpk;
         delete per;
         delete key;
         break;
   }
   delete msg;
   Timer2->Enabled = false; Sleep(100); //if (Mode!=mPGPverify) Sleep(100);
   Hide(); AppProcessMessages(); //Sleep(100); if (Mode!=mPGPverify) Sleep(100);
   if (ModalResult==mrNone) ModalResult=mrOk;
 }
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::Timer2Timer(TObject *Sender)
{
   if (Label1->Caption.IsEmpty()) Label1->Caption = Cap;
   else Label1->Caption = "";
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::FormShow(TObject *Sender)
{
   CenterDialog(this,ActMainForm);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
int __fastcall TPgpDlg::Execute(int mode)
{
//sm((int)dat->length);
   Mode = mode; ShowModal();
//sm((int)Result);
//sm((int)dat->length);
   return Result;
}
//---------------------------------------------------------------------------
void __fastcall TPgpDlg::PGPerror(AnsiString &errorStr, AnsiString title)
{
   MsgBoxHwnd(Handle,errorStr,title,MB_OK);
}
//---------------------------------------------------------------------------








